<?php

if (file_exists('../../../dbconnect.php'))
{
	include('../../../dbconnect.php');
}
elseif (file_exists('../../../init.php'))
{
	define('WHMCSDBCONNECT', true);
	include('../../../init.php');
}
else
{
	die();
}
include('../../../includes/functions.php');
include('../../../includes/gatewayfunctions.php');
include('../../../includes/invoicefunctions.php');

$gatewaymodule = 'oxapay'; 
$GATEWAY = getGatewayVariables($gatewaymodule);
if (!$GATEWAY['type'])
{
	die('Module OxaPay Payment Gateway Not Activated');
}

$postData = file_get_contents('php://input');
$data = json_decode($postData);
if ($data->type === 'payment') {
	if ($_SERVER['HTTP_HMAC'] === hash_hmac('sha512', $postData, $GATEWAY['merchant'])) {
		$code = $_GET['code'];
		$code = checkCbInvoiceID($code, $GATEWAY['name']);
		if ($data->status == 'Waiting') {
			$message = 'Payment Status is Waiting';
			logTransaction($GATEWAY['name'], array_merge($_REQUEST,$data,$message), 'Unsuccessful');
		} elseif ($data->status == 'Failed') {
			$message = 'Payment Status is Failed';
			logTransaction($GATEWAY['name'], array_merge($_REQUEST,$data,$message), 'Unsuccessful');
		} elseif ($data->status == 'Expired') {
			$message = 'Payment Status is Expired';
			logTransaction($GATEWAY['name'], array_merge($_REQUEST,$data,$message), 'Unsuccessful');
		} elseif ($data->status != 'Paid') {
			$message = sprintf("Payment Status is Not Paid (%s)", $data->status);
			logTransaction($GATEWAY['name'], array_merge($_REQUEST,$data,$message), 'Unsuccessful');
		} else {
			checkCbTransID($code);
			addInvoicePayment($code, $code, $data->invoiceAmount, 0, $gatewaymodule);
			logTransaction($GATEWAY['name'], array_merge($_REQUEST,$data), 'Successful');
		}
		http_response_code(200);
		echo 'ok';
		exit;
	} else {
		http_response_code(400);
		echo 'Invalid HMAC signature';
		exit;
	}
} else {
	http_response_code(400);
	echo 'Invalid data.type';
	exit;
}

?>