<?php

function oxapay_config()
{
	$Currencies = array(
			'Type'         => 'text',
			'FriendlyName' => 'OxaPay Currency',
			'Size'         => '20'
		);
	try {
		$gatewaymodule = 'oxapay';
		$GATEWAY = getGatewayVariables($gatewaymodule);
		$b = array(
			'merchant'    => $GATEWAY['merchant'],
		);
		$h = array('Content-Type' => 'application/json', 'Accept' => 'application/json');
		$u = 'https://api.oxapay.com/merchants/allowedCoins';
		$ch = curl_init($u);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($b));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $h);
		$result = curl_exec($ch);
		curl_close($ch);
		$response = json_decode($result);
		if ($response->result == 100)
		{
			$coins = array('');
			foreach ($response->allowed as $coin) {
				$coins[$coin] = $coin;
			}
			$Currencies = array(
					'Type'         => 'dropdown',
					'FriendlyName' => 'OxaPay Currency',
					'Options'      => implode(',', $coins)
				);
		}
	} catch (exception $e) { }
	return array(
		'FriendlyName' => array(
				'Type'  => 'System',
				'Value' => 'OxaPay'
			),
		'merchant' => array(
				'Type'         => 'text',
				'FriendlyName' => 'OxaPay Merchant',
				'Size'         => '50'
			),
		'Currencies' => $Currencies,
		'lifetime' => array(
				'Type'         => 'text',
				'FriendlyName' => 'Transaction Life (Expire) Time minutes. between 15-2880',
				'Size'         => '50'
			),
	);	
}

function oxapay_link($params)
{
	try
	{
		$c = $params['systemurl'].'/modules/gateways/callback/oxapay.php?amount='.$params['amount'].'&code='.$params['invoiceid'].'&shf_key='.session_id();
		$b = array(
			'merchant'    => $params['merchant'],
			'lifeTime'    => $params['lifetime'],
			'amount'      => floatval($params['amount']),
			'description' => 'WHMCS_Invoice_'.$params['invoiceid'],
			'orderId'     => strval($params['invoiceid']), // $now,
			'email'       => @$params['clientdetails']['email'],
			'callbackUrl' => str_replace('http://', 'https://', $c),
			'returnUrl'   => $params['systemurl'].'/viewinvoice.php?id='.$params['invoiceid'],
		);
		if ($params['Currencies']) {
			$b['currency'] = $params['Currencies'];
		}
		$h = array('Content-Type' => 'application/json', 'Accept' => 'application/json');
		$u = 'https://api.oxapay.com/merchants/request';
		$ch = curl_init($u);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($b));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $h);
		$result = curl_exec($ch);
		curl_close($ch);
		$response = json_decode($result);
		if ($response->result == 100)
		{
			$_SESSION['oxapay'] = array($params['invoiceid'], $params['amount'], $response->trackId);
			return '<a class="oxapay_btn" href="'.$response->payLink.'">'.(@$params['langpaynow']?:'Continue Pay...').'</a>
					<style>
						.oxapay_btn {
								font-size: 16px;
								width: 70%;
								min-width: 100px;
								margin: 20px 0;
								background-color: #4CAF50;
								border: none;
								color: white;
								padding: 7px 32px;
							}
					</style>';
		}
		else
		{
			throw new Exception($response->message);
		}
	}
	catch (Exception $ex)
	{
		return '<p><font color="red">Error : '.$ex->getMessage().'</font></p><form name="frmPay" method="post" action="'.$params['systemurl'].'/viewinvoice.php?id='.$params['invoiceid'].'"><input type="submit" value="Try Again!" /></form>';
	}
}

add_hook('ClientAreaPageViewInvoice', 1, function($vars) {
	$out = array();
	if (isset($_GET['paymentSuccess'])) {
    	$out['paymentSuccess'] = true;
    } else if (isset($_GET['paymentFailed'])) {
    	$out['paymentFailed'] = true;
    }
    if (isset($_GET['errMsg'])) {
    	$out['notes'] = $_GET['errMsg'];
    }
    return $out;
});

?>